package com.example.photowebcamshmeleff;

import android.content.Context;
import android.util.Log;
import org.apache.commons.net.ftp.FTP;
import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPReply;
import java.io.FileInputStream;


public class MyFTPClientFunctions {
    private FTPClient mFTPClient;
    private MyFTPClientFunctions ftpclient = null;
    private static final String TAG = "myLogs";
    private static String GenFileName = " "; // ГЕНЕРИРУЕМЛЕ имя фотографии с цифрой
    public int nnum = 0; //Порядковый номер картинки
    public String printTxtViewFTP = "FTP upload complete"; // Переменная для вывода данных в телеметрии через MainActivitys


    //==============================================
    //    Подключение к FTP серверу
    //==============================================
    public boolean ftpConnect(String host, String username, String password, int port) {
        try {
            mFTPClient = new FTPClient();
            // connecting to the host
            mFTPClient.connect(host, port);
            // now check the reply code, if positive mean connection success
            if (FTPReply.isPositiveCompletion(mFTPClient.getReplyCode())) {
                // login using username & password
                boolean status = mFTPClient.login(username, password);
                /*
                 * Set File Transfer Mode
                 * To avoid corruption issue you must specified a correct
                 * transfer mode, such as ASCII_FILE_TYPE, BINARY_FILE_TYPE,
                 * EBCDIC_FILE_TYPE .etc. Here, I use BINARY_FILE_TYPE for
                 * transferring text, image, and compressed files.
                 */
                mFTPClient.setFileType(FTP.BINARY_FILE_TYPE);
                mFTPClient.enterLocalPassiveMode();
                Log.d(TAG, "== FTP Connect Level ==: " + mFTPClient.getStatus().toString());       // Полный путь /storage/emulated/0/DCIM/test1.jpg
                return status;
            }
        } catch (Exception e) {
            Log.d(TAG, "== == Error: could not connect to host == ==" + host + " == e : == " + e);
        }
        return false;
    } // http://oflameron.com


    //==============================================
    //    Отключение FTP сервера
    //==============================================
    public boolean ftpDisconnect() {
        try {
            mFTPClient.logout();
            mFTPClient.disconnect();
            Log.d(TAG, "== == Disconnect from ftp server == ==");
            return true;
        } catch (Exception e) {
            Log.d(TAG, "== == Error occurred while disconnecting from ftp server == ==");
        }
        return false;
    }


    //==============================================
    //    Загрузка файла на FTP сервер
    //==============================================
    public boolean ftpUpload(String srcFilePath, String desFileName, String desDirectory, Context context, Integer ipnumber) {
        boolean status = false;

        try {
            //=======================================================
            //           Перед загрузкой файла надо перейти
            //           в нужный каталог на FTP сервере
            //=======================================================
            ////mFTPClient.changeWorkingDirectory("public_html"); //Каталог на FTP сервере для загрузки файла
            mFTPClient.changeWorkingDirectory(desDirectory); // То же самое, только имя каталога - передаем из MainActivity.java
            //  Загрузить файл на FTP сервер
            FileInputStream srcFileStream = new FileInputStream(srcFilePath);
            //==========================================
            //ГЕНЕРИРОВАТЬ имя файла картинки с номером
            //==========================================
            if (nnum >= ipnumber+1) //Получили ipnumber из SETUP - количество картинок в сессию
            {
                nnum = 0; //Начать нумерацию картинок заново
            }
            nnum = nnum + 1;
            GenFileName = desFileName + nnum + ".jpg"; //ГЕНЕРИРОВАТЬ имя файла картинки с номером
            //==========================================
            status = mFTPClient.storeFile(GenFileName, srcFileStream);
            srcFileStream.close();
            if (status == true) {
                printTxtViewFTP = "FTP upload success";
            }
            if (status == false) {
                printTxtViewFTP = "FTP upload err";
            }
            return status;
        } catch (Exception e) {
            printTxtViewFTP = "FTP Upload failed";
            e.printStackTrace();
        }
        return status;
    }

}
